org.apache.catalina.realm

## Class MemoryRealm

- java.lang.Object
- - org.apache.catalina.util.LifecycleBase
  - - org.apache.catalina.util.LifecycleMBeanBase
    - - org.apache.catalina.realm.RealmBase
      - - org.apache.catalina.realm.MemoryRealm

- All Implemented Interfaces:
    MBeanRegistration, Lifecycle, Realm
  Direct Known Subclasses:
    JAASMemoryLoginModule

      public class MemoryRealm
      extends RealmBase

  Simple implementation of Realm that reads an XML file to configure the valid users, passwords, and roles. The file format (and default file location) are identical to those currently supported by Tomcat 3.X.

  IMPLEMENTATION NOTE: It is assumed that the in-memory collection representing our defined users (and their roles) is initialized at application startup and never modified again. Therefore, no thread synchronization is performed around accesses to the principals collection.

  Author:
    Craig R. McClanahan

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.catalina.realm.RealmBase

      `RealmBase.AllRolesMode`

    - ### Nested classes/interfaces inherited from interface org.apache.catalina.Lifecycle

      `Lifecycle.SingleUse`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static String` | `info` Descriptive information about this Realm implementation.
    `protected static String` | `name` Descriptive information about this Realm implementation.

    - ### Fields inherited from class org.apache.catalina.realm.RealmBase

      `allRolesMode, container, containerLog, digest, digestEncoding, md, md5Encoder, md5Helper, realmPath, sm, stripRealmForGss, support, validate, x509UsernameRetriever, x509UsernameRetrieverClassName`

    - ### Fields inherited from class org.apache.catalina.util.LifecycleMBeanBase

      `mserver`

    - ### Fields inherited from interface org.apache.catalina.Lifecycle

      `AFTER_DESTROY_EVENT, AFTER_INIT_EVENT, AFTER_START_EVENT, AFTER_STOP_EVENT, BEFORE_DESTROY_EVENT, BEFORE_INIT_EVENT, BEFORE_START_EVENT, BEFORE_STOP_EVENT, CONFIGURE_START_EVENT, CONFIGURE_STOP_EVENT, PERIODIC_EVENT, START_EVENT, STOP_EVENT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MemoryRealm()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Principal` | `authenticate(String username, String credentials)` Return the Principal associated with the specified username and credentials, if there is one; otherwise return `null`.
    `protected Digester` | `getDigester()` Return a configured `Digester` to use for processing the XML input file, creating a new one if necessary.
    `String` | `getInfo()` Return descriptive information about this Realm implementation and the corresponding version number, in the format `<description>/<version>`.
    `protected String` | `getName()` Return a short name for this Realm implementation.
    `protected String` | `getPassword(String username)` Return the password associated with the given principal's user name.
    `String` | `getPathname()` Return the pathname of our XML file containing user definitions.
    `protected Principal` | `getPrincipal(String username)` Return the Principal associated with the given user name.
    `protected Map<String,GenericPrincipal>` | `getPrincipals()` Deprecated. Unused
    `void` | `setPathname(String pathname)` Set the pathname of our XML file containing user definitions.
    `protected void` | `startInternal()` Prepare for the beginning of active use of the public methods of this component and implement the requirements of `LifecycleBase.startInternal()`.

    - ### Methods inherited from class org.apache.catalina.realm.RealmBase

      `addPropertyChangeListener, authenticate, authenticate, authenticate, authenticate, backgroundProcess, compareCredentials, digest, Digest, findSecurityConstraints, getAllRolesMode, getContainer, getDigest, getDigest, getDigestCharset, getDigestEncoding, getDomainInternal, getObjectNameKeyProperties, getPrincipal, getPrincipal, getRealmPath, getRealmSuffix, getServer, getTransportGuaranteeRedirectStatus, getValidate, getX509UsernameRetrieverClassName, hasMessageDigest, hasResourcePermission, hasRole, hasUserDataPermission, initInternal, isStripRealmForGss, main, removePropertyChangeListener, setAllRolesMode, setContainer, setDigest, setDigestEncoding, setRealmPath, setStripRealmForGss, setTransportGuaranteeRedirectStatus, setValidate, setX509UsernameRetrieverClassName, stopInternal, toString`

    - ### Methods inherited from class org.apache.catalina.util.LifecycleMBeanBase

      `destroyInternal, getDomain, getObjectName, postDeregister, postRegister, preDeregister, preRegister, register, setDomain, unregister`

    - ### Methods inherited from class org.apache.catalina.util.LifecycleBase

      `addLifecycleListener, destroy, findLifecycleListeners, fireLifecycleEvent, getState, getStateName, init, removeLifecycleListener, setState, setState, start, stop`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### info

          protected static final String info

      Descriptive information about this Realm implementation.
      See Also:
        Constant Field Values

    - #### name

          protected static final String name

      Descriptive information about this Realm implementation.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### MemoryRealm

          public MemoryRealm()

  - ### Method Detail

    - #### getInfo

          public String getInfo()

      Return descriptive information about this Realm implementation and the corresponding version number, in the format `<description>/<version>`.
      Specified by:
        `getInfo` in interface `Realm`
      Overrides:
        `getInfo` in class `RealmBase`

    - #### getPathname

          public String getPathname()

      Return the pathname of our XML file containing user definitions.

    - #### setPathname

          public void setPathname(String pathname)

      Set the pathname of our XML file containing user definitions. If a relative pathname is specified, it is resolved against "catalina.base".
      Parameters:
        `pathname` - The new pathname

    - #### authenticate

          public Principal authenticate(String username,
                               String credentials)

      Return the Principal associated with the specified username and credentials, if there is one; otherwise return `null`.
      Specified by:
        `authenticate` in interface `Realm`
      Overrides:
        `authenticate` in class `RealmBase`
      Parameters:
        `username` - Username of the Principal to look up
        `credentials` - Password or other credentials to use in authenticating this username

    - #### getDigester

          protected Digester getDigester()

      Return a configured `Digester` to use for processing the XML input file, creating a new one if necessary.

    - #### getName

          protected String getName()

      Return a short name for this Realm implementation.
      Specified by:
        `getName` in class `RealmBase`

    - #### getPassword

          protected String getPassword(String username)

      Return the password associated with the given principal's user name.
      Specified by:
        `getPassword` in class `RealmBase`

    - #### getPrincipal

          protected Principal getPrincipal(String username)

      Return the Principal associated with the given user name.
      Specified by:
        `getPrincipal` in class `RealmBase`

    - #### getPrincipals

          @Deprecated
          protected Map<String,GenericPrincipal> getPrincipals()

      Deprecated. Unused
      Returns the principals for this realm.
      Returns:
        The principals, keyed by user name (a String)

    - #### startInternal

          protected void startInternal()
                                throws LifecycleException

      Prepare for the beginning of active use of the public methods of this component and implement the requirements of `LifecycleBase.startInternal()`.
      Overrides:
        `startInternal` in class `RealmBase`
      Throws:
        `LifecycleException` - if this component detects a fatal error that prevents this component from being used

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.